=== debian/changelog ===
neovim (0.3.4-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- James McCoy <jamessan@debian.org>  Tue, 23 Jul 2019 21:17:43 -0400

neovim (0.3.4-3) unstable; urgency=high

  * Backport additional changes to address CVE-2019-12735 (Closes: #930024)
    + vim-patch:8.1.0177: defining function in sandbox is inconsistent
    + vim-patch:8.1.0189: function defined in sandbox not tested
    + vim-patch:8.1.0538: evaluating a modeline might invoke using a shell
      command
    + vim-patch:8.1.0539: cannot build without the sandbox
    + vim-patch:8.1.0540: may evaluate insecure value when appending to option
    + vim-patch:8.1.0544: setting 'filetype' in a modeline causes an error
    + vim-patch:8.1.0613: when executing an insecure function the secure flag
      is stuck
    + vim-patch:8.1.1046: the "secure" variable is used inconsistently
    + vim-patch:8.1.0205: invalid memory access with invalid modeline
    + vim-patch:8.1.0206: duplicate test function name
    + vim-patch:8.1.0506: modeline test fails when run by root
    + vim-patch:8.1.0546: modeline test with keymap fails
    + vim-patch:8.1.0547: modeline test with keymap still fails
    + vim-patch:8.1.1366: using expressions in a modeline is unsafe
    + vim-patch:8.1.1367: can set 'modelineexpr' in modeline
    + vim-patch:8.1.1368: modeline test fails with python but without
      pythonhome
    + vim-patch:8.1.1382: error when editing test file
    + vim-patch:8.1.1401: misspelled mkspellmem as makespellmem
  * Backport patch to prevent use of nvim's API within the sandbox

 -- James McCoy <jamessan@debian.org>  Wed, 26 Jun 2019 21:21:33 -0400

neovim (0.3.4-2) unstable; urgency=high

  [ Efraim Flashner ]
  * don't use luajit on powerpc

  [ James McCoy ]
  * Use the system allocator instead of jemalloc

  [ Justin M. Keyes ]
  * vim-patch:8.1.1365: :source should check sandbox (Closes: #930024,
    CVE-2019-12735)

 -- James McCoy <jamessan@debian.org>  Wed, 05 Jun 2019 21:38:14 -0400

neovim (0.3.4-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Bump libunibilium-dev Build-Depends to 2.0.0-3 to handled the changes to
    terminfo's extended capability format (c.f., #904337).

 -- James McCoy <jamessan@debian.org>  Mon, 22 Apr 2019 20:30:06 -0400

neovim (0.3.4-1) unstable; urgency=medium

  * New upstream release
  * Explicitly downgrade _FORTIFY_SOURCE to 1
  * Build-Depend on jemalloc >= 5.1 for archs with varying page size

 -- James McCoy <jamessan@debian.org>  Sun, 13 Jan 2019 16:04:16 -0500

neovim (0.2.2-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- James McCoy <jamessan@debian.org>  Mon, 04 Jun 2018 08:10:52 -0400
